#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN WAS DEVELOPED AND TESTED UNDER WINDOWS VISTA ONLY AND MAY OR MAY NOT WORK ON A MAC. 
# -----------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
# -----------------------------------------------------------------------------------------------
#    Name:	Random Protrusion
#      By:	sdmitch
#   Usage:	Pushpull faces to a random height in a specified range and interval
#		 Note:	
#			
#    Date:	Jun 2012
#------------------------------------------------------------------------------------------------
#
require 'Sketchup'
#
if not file_loaded?(File.basename(__FILE__))
    UI.menu('Plugins').add_item('Random Protrusion') { Random_Protrusion.main }
	 file_loaded(File.basename(__FILE__))
end
#
module Random_Protrusion
	def self.main
		mod = Sketchup.active_model
		ent = mod.entities
		sel = mod.selection
		unless sel.empty?
			faces=sel.select{|f| f.is_a?(Sketchup::Face)}
			unless faces.empty?
				inp = inputbox(["Min:","Max:","Int:"],[8,24,4],"Random Protrusion")
				if !inp then return nil end
				mod.start_operation "Random Protrusion"
				min=inp[0].to_i;max=inp[1].to_i;int=inp[2].to_i;ppd=[]
				min.step(max,int) {|d| ppd<<d}
				faces.each{|f| f.reverse! if f.normal.z < 0.0;f.pushpull ppd[rand(ppd.length)]}
				mod.commit_operation
			else
				UI.messagebox "No faces found in the selection"
			end
		else
			UI.messagebox "Nothing selected"
		end
	end
end
